// this code is programed auto by dialog editor.
#include <sstream>
#include <cstdio>
#include "_APPNAME_Application.h"
#include "_APPNAME_DialogMaker.h"

#define debugs  { cout << __FILE__ << ':' << __LINE__ << ':' << __FUNCTION__ << endl; }

_APPNAME_Application::_APPNAME_Application(PGDialogMaker& dm) : PGApplication(dm)
{
    debugs;
}

//-----------------------------------------------------------------------------
int _APPNAME_Application::OnInit()
{
    debugs;
    // アプリケーションで必要な初期化を行って下さい

    // サンプル（認証で乱数を使用する）
    srand(time(NULL));

	// サンプル
	// 共有タイプのダイアログで端末の接続が無くても予めリソースを用意しておく必要がある場合は
	// ここでダイアログを生成します。
	// 端末からの接続があると自動的にダイアログが生成されます。
	// 予め準備しておく必要がない場合は何もしなくてもOKです。

	// ダイアログ名を指定してダイアログを生成する
	// app->CreateDialog("Shared");


	// サンプル
	// タイマーを使う場合。OnTimer()で処理を行います。
    // SetApplicationTimerInterval(10*1000,100);      // 繰り返し１０秒タイマ、ID=100
	// SetApplicationSingleTimerInterval(5*1000,200); // １回のみ  ５秒タイマ、ID=200
    return 0;
}

bool _APPNAME_Application::OnAuth( const SGString &name, const SGString &pass, PGClientSocket *pgsock )
{
    debugs;
    // ログインネーム、パスワードを確認し認証をおこなって下さい
    // 認証に成功したら、認証処理（セッションIDの登録）を行ってください。
    
    // このサンプルでは認証にguest/guestを使用する
    // セッションIDはランダムな値を設定する（すべての接続は別個のセッションと扱う）
    if( name=="guest" && pass=="guest" ){

        stringstream ss;
        ss << rand() << '-' << time(NULL);
        SGString sessionid = ss.str();
        
        cout << "SESSIONID:" << sessionid << endl;

	    // セッションリストを確認し、存在しなければ作る
		CreateSession(sessionid,TIMEOUT_SESSION*1000);

        // 認証（セッションIDの登録）
        pgsock->Authentication(sessionid);
    }
    return true;
}


void _APPNAME_Application::OnStart(PGClientSocket *pgsock,SGString& type ,int width ,int height)
{
    debugs;
	// この関数は、クライアントアプリケーションが起動時に発行する HELLO コマンドを受信した時にコールバックされます。
	// 端末側プログラムの起動時に合わせて処理を行う場合は、ここで行います。
	// 基本クラスの PGApplication::OnStart(pgsock,type ,width ,height); をコールすると、
	// 「Top.json」を開くコマンドが送信されます。
	// 初期画面を Top.json ダイアログ以外のファイルを指定したい場合は、ここで OPEN コマンドなどを発行し、
	// 基本クラスの呼び出しを停止してください。
	// この時発行するコマンドには必ず SessionId をつけて下さい。
	// ※コマンドの発行は必須です。処理が必要無い場合は KEEPALIVE にセッションIDを付加して送信して下さい。
	PGApplication::OnStart(pgsock,type ,width ,height);
}

void _APPNAME_Application::OnTimer(TimeVal tv,unsigned int id)
{
	// 次のいづれかの関数で登録されたタイマが指定の時間になった時にコールバックされます。
	// ・SetApplicationTimerInterval(interval,id);
	// ・SetApplicationSingleTimerInterval(interval,id);
	// どのタイマーイベントが発生しているかをidで判断します。
}

